<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output omit-xml-declaration="no"
            encoding=""
            indent="yes"
            media-type="text/aiml"
            standalone="yes" />
<!-- Default Rule -->
<xsl:template match="*|@*|text()">
<xsl:copy>
<xsl:copy-of select="@*"/>
<xsl:apply-templates select="*|@*|text()" />
</xsl:copy>
</xsl:template>

                
<!-- AIML Headers -->

<xsl:template match="meta"/>
<xsl:template match="processing-instruction()|comment()"/>

<xsl:template match="aiml">
<aiml version="1.0">
<xsl:comment>Free software (c) 2001 ALICE AI Foundation</xsl:comment>
<xsl:comment>This program is open source code released under</xsl:comment>
<xsl:comment>the terms of the GNU General Public Licenser</xsl:comment>
<xsl:comment>and published by the Free Software Foundation</xsl:comment>
<meta name="author" content="AIML-0.9-1.0"/>
<meta name="language" content="EN"/>
<xsl:apply-templates/>
</aiml>
</xsl:template>

<!-- AIML Standard 1.0 Tags -->

<xsl:template match="get|bot|that|input|star|topicstar|thatstar">
<xsl:copy-of select="."/>
</xsl:template>

<xsl:template match="trimleft|trimright|subst|now|change|property|spc|onevent|flush|bye">
<xsl:copy-of select="."/>
</xsl:template>


<xsl:template match="*">
 <xsl:variable name="var01" select="name()"/>
 <xsl:variable name="var02" select="substring-before(name(),'_')"/>
 <xsl:variable name="var03" select="substring-after(name(),'_')"/>
 <xsl:variable name="var04" select="@name"/>
 <xsl:choose>
 <xsl:when test="contains(name(),'set')=true() and contains(name(),'_')=true()">
    <set name="{$var03}"><xsl:value-of select="."/></set>
 </xsl:when>
 <xsl:when test="contains(name(),'get')=true() and contains(name(),'_')=true()">
    <get name="{$var03}"/>
 </xsl:when>
 <xsl:when test="contains(name(),'set')=true() and contains(name(),'_')=false() and count(./node())=0">
    <set name="{$var04}"><star /></set>
 </xsl:when>
 <xsl:otherwise>
  <xsl:copy>
  <xsl:copy-of select="@*"/>
  <xsl:apply-templates select="*|@*|text()" />
  </xsl:copy>
 </xsl:otherwise>
 </xsl:choose>
</xsl:template>
                                       
</xsl:stylesheet>
